#include <stdio.h>
#include <pthread.h>
#include <stdlib.h>
#include <string.h>
#include "exc_handling.h"
#include "pthread_exc.h"
#include "dcethread.h"

EXCEPTION exc_MYException;

void * somethread(void *da)
{
 int y = 0;
 char bigbuf[1024];
  
 if(da) y = (int)da;
  
 TRY 
  {
   pthread_yield();
   sleep(30);
   printf("My TID is %lu\n", pthread_self());
   if(y) 
   { 
    printf("Raising Exception\n");
    fflush(stdout); 
   /*RAISE(exc_e_SIGSEGV);*/
   /*kill(getpid(), 1);*/
   /*strcpy((char*)999823, (char*)024);*/
    RAISE(exc_MYException);
    printf("Raised\n"); 
    fflush(stdout);
   }
  }
  CATCH(exc_e_SIGSEGV)
  {
   sprintf(bigbuf, "TID %lu (%u) caught SIGSEGV\n", pthread_self(),getpid());
   write(1, bigbuf, strlen(bigbuf));
   pthread_exit((void*)0);
  }
  CATCH_ALL 
  {
     printf("Caught something.\n");
     fflush(stdout);
     pthread_exit(0);
  }
  ENDTRY
}


int main(int argc, char **argv)
{
 int i;
 pthread_t w[20];
 void *st;

 EXCEPTION_INIT(exc_MYException);
 for(i=0; i<10 ;i++)
 {
  if(i==6) pthread_create(&w[i], NULL, somethread, (void*)1);
  else pthread_create(&w[i], NULL, somethread, NULL);
 }
  
 for(i=0; i<10; i++)
 { 
  pthread_join(w[i], &st);
  printf("Joined %lu (%u)\n ", w[i],i);
 }
}
